diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeBorealForest.java b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeBorealForest.java
index a26de87fb..ac4abe021 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeBorealForest.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeBorealForest.java
@@ -4,8 +4,9 @@ import net.minecraft.core.entity.animal.MobWolf;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.SpawnListEntry;
 import net.minecraft.core.world.biome.Biome;
-import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeTaigaBushy;
 import net.minecraft.core.world.generate.feature.WorldFeature;
+import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeTaigaBushy;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
@@ -19,7 +20,7 @@ public class BiomeBorealForest extends Biome
     }
 
     @Override
-	public WorldFeature getRandomWorldGenForTrees(Random random)
+	public @NotNull WorldFeature getTreeFeature(@NotNull Random random)
     {
         return new WorldFeatureTreeTaigaBushy(Blocks.LEAVES_PINE.id(), Blocks.LOG_PINE.id());
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeCaatinga.java b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeCaatinga.java
index 793dba71d..4757f4502 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeCaatinga.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeCaatinga.java
@@ -6,8 +6,9 @@ package net.minecraft.core.world.biome.overworld;
 
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.biome.Biome;
-import net.minecraft.core.world.generate.feature.tree.*;
 import net.minecraft.core.world.generate.feature.WorldFeature;
+import net.minecraft.core.world.generate.feature.tree.*;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
@@ -19,7 +20,7 @@ public class BiomeCaatinga extends Biome
     }
 
     @Override
-    public WorldFeature getRandomWorldGenForTrees(Random random)
+    public @NotNull WorldFeature getTreeFeature(@NotNull Random random)
     {
         if(random.nextInt(3) != 0)
         {
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeDesert.java b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeDesert.java
index 63df9e873..66bdeea7d 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeDesert.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeDesert.java
@@ -6,6 +6,7 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.generate.feature.WorldFeature;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreePalm;
+import org.jetbrains.annotations.NotNull;
 
 public class BiomeDesert extends Biome
 {
@@ -15,7 +16,7 @@ public class BiomeDesert extends Biome
         super(key);
     }
     @Override
-    public WorldFeature getRandomWorldGenForTrees(Random random) {
+    public @NotNull WorldFeature getTreeFeature(@NotNull Random random) {
 
         return new WorldFeatureTreePalm(Blocks.LOG_PALM, Blocks.LEAVES_PALM, random.nextInt(10) == 0, false, true);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeForest.java b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeForest.java
index 458603e3e..9517a9aa0 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeForest.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeForest.java
@@ -4,9 +4,10 @@ import net.minecraft.core.entity.animal.MobWolf;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.SpawnListEntry;
 import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.generate.feature.WorldFeature;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTree;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeFancy;
-import net.minecraft.core.world.generate.feature.WorldFeature;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
@@ -20,7 +21,7 @@ public class BiomeForest extends Biome
     }
 
     @Override
-	public WorldFeature getRandomWorldGenForTrees(Random random)
+	public @NotNull WorldFeature getTreeFeature(@NotNull Random random)
     {
         if(random.nextInt(5) == 0)
         {
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeOutback.java b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeOutback.java
index 956cc2e29..751da21e0 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeOutback.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeOutback.java
@@ -4,8 +4,9 @@ import net.minecraft.core.entity.monster.MobSpider;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.SpawnListEntry;
 import net.minecraft.core.world.biome.Biome;
-import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeEucalyptus;
 import net.minecraft.core.world.generate.feature.WorldFeature;
+import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeEucalyptus;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
@@ -22,7 +23,7 @@ public class BiomeOutback extends Biome
     }
 
     @Override
-	public WorldFeature getRandomWorldGenForTrees(Random random)
+	public @NotNull WorldFeature getTreeFeature(@NotNull Random random)
     {
         return new WorldFeatureTreeEucalyptus(Blocks.LEAVES_EUCALYPTUS.id(), Blocks.LOG_EUCALYPTUS.id());
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomePlains.java b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomePlains.java
index 5bcc35fee..90767bf7b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomePlains.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomePlains.java
@@ -4,6 +4,7 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.generate.feature.WorldFeature;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeEucalyptus;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
@@ -14,7 +15,7 @@ public class BiomePlains extends Biome
     }
 
     @Override
-    public WorldFeature getRandomWorldGenForTrees(Random random)
+    public @NotNull WorldFeature getTreeFeature(@NotNull Random random)
     {
         return new WorldFeatureTreeEucalyptus(Blocks.LEAVES_EUCALYPTUS.id(), Blocks.LOG_EUCALYPTUS.id());
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeRainforest.java b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeRainforest.java
index 10944c5c0..d26cb3c72 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeRainforest.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeRainforest.java
@@ -10,6 +10,7 @@ import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeFancyRainf
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreePalm;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeShrub;
 import net.minecraft.core.world.generate.feature.tree.spooner.WorldFeatureSpoonerTreeRound;
+import org.jetbrains.annotations.NotNull;
 
 public class BiomeRainforest extends Biome
 {
@@ -20,7 +21,7 @@ public class BiomeRainforest extends Biome
     }
 
 	@Override
-	public WorldFeature getRandomWorldGenForTrees(Random random) {
+	public @NotNull WorldFeature getTreeFeature(@NotNull Random random) {
 		if(random.nextInt(1000) == 0) {
 			int treeHeight = 30 + random.nextInt(30);
 			return new WorldFeatureSpoonerTreeRound(treeHeight, Blocks.LOG_OAK.id(), 0, Blocks.LEAVES_OAK.id(), 0);
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeRetro.java b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeRetro.java
index 16284c0e2..0ce25763c 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeRetro.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeRetro.java
@@ -8,6 +8,7 @@ import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.generate.feature.WorldFeature;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTree;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeFancy;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
@@ -34,7 +35,7 @@ public class BiomeRetro
     }
 
     @Override
-    public WorldFeature getRandomWorldGenForTrees(Random random)
+    public @NotNull WorldFeature getTreeFeature(@NotNull Random random)
     {
         WorldFeature feature = new WorldFeatureTree(Blocks.LEAVES_OAK.id(), Blocks.LOG_OAK.id(), 4);
         if (random.nextInt(10) == 0)
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeSeasonalForest.java b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeSeasonalForest.java
index a7dedb093..312a1d063 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeSeasonalForest.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeSeasonalForest.java
@@ -4,10 +4,11 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.SpawnListEntry;
 import net.minecraft.core.entity.animal.MobWolf;
 import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.generate.feature.WorldFeature;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeCherry;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTree;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeFancy;
-import net.minecraft.core.world.generate.feature.WorldFeature;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
@@ -20,7 +21,7 @@ public class BiomeSeasonalForest extends Biome
         spawnableCreatureList.add(new SpawnListEntry(MobWolf.class, 25));
     }
     @Override
-	public WorldFeature getRandomWorldGenForTrees(Random random)
+	public @NotNull WorldFeature getTreeFeature(@NotNull Random random)
     {
         if(random.nextInt(3) == 0)
         {
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeShrubland.java b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeShrubland.java
index 8ed06dd22..8d7972525 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeShrubland.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeShrubland.java
@@ -2,8 +2,9 @@ package net.minecraft.core.world.biome.overworld;
 
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.biome.Biome;
-import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeShrub;
 import net.minecraft.core.world.generate.feature.WorldFeature;
+import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeShrub;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
@@ -14,7 +15,7 @@ public class BiomeShrubland extends Biome
 	}
 
 	@Override
-	public WorldFeature getRandomWorldGenForTrees(Random random)
+	public @NotNull WorldFeature getTreeFeature(@NotNull Random random)
     {
         return new WorldFeatureTreeShrub(Blocks.LEAVES_SHRUB.id(), Blocks.LOG_OAK.id());
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeSwamp.java b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeSwamp.java
index 783b8737d..bcaab071d 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeSwamp.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeSwamp.java
@@ -2,8 +2,9 @@ package net.minecraft.core.world.biome.overworld;
 
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.biome.Biome;
-import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeShapeSwamp;
 import net.minecraft.core.world.generate.feature.WorldFeature;
+import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeShapeSwamp;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
@@ -14,7 +15,7 @@ public class BiomeSwamp extends Biome
 	}
 
 	@Override
-	public WorldFeature getRandomWorldGenForTrees(Random random)
+	public @NotNull WorldFeature getTreeFeature(@NotNull Random random)
     {
         return new WorldFeatureTreeShapeSwamp(Blocks.LEAVES_OAK.id(), Blocks.LOG_OAK_MOSSY.id(), 6);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeTaiga.java b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeTaiga.java
index b27ab4794..8466fb697 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeTaiga.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeTaiga.java
@@ -4,9 +4,10 @@ import net.minecraft.core.entity.animal.MobWolf;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.SpawnListEntry;
 import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.generate.feature.WorldFeature;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeTaigaBushy;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeTaigaTall;
-import net.minecraft.core.world.generate.feature.WorldFeature;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
@@ -20,7 +21,7 @@ public class BiomeTaiga extends Biome
     }
 
     @Override
-	public WorldFeature getRandomWorldGenForTrees(Random random)
+	public @NotNull WorldFeature getTreeFeature(@NotNull Random random)
     {
         if(random.nextInt(3) == 0)
         {
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/overworld/legacy/BiomeForestLegacy.java b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/legacy/BiomeForestLegacy.java
index 66d2bd8cc..d5a6c55a2 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/overworld/legacy/BiomeForestLegacy.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/legacy/BiomeForestLegacy.java
@@ -7,6 +7,7 @@ import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.generate.feature.WorldFeature;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTree;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeFancy;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
@@ -19,7 +20,7 @@ public class BiomeForestLegacy
     }
 
     @Override
-    public WorldFeature getRandomWorldGenForTrees(final Random random) {
+    public @NotNull WorldFeature getTreeFeature(final @NotNull Random random) {
         if (random.nextInt(5) == 0) {
             return new WorldFeatureTree(Blocks.LEAVES_BIRCH.id(), Blocks.LOG_BIRCH.id(), 5);
         } else {
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/overworld/legacy/BiomeRainforestLegacy.java b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/legacy/BiomeRainforestLegacy.java
index 3faa48598..6fe406ccf 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/overworld/legacy/BiomeRainforestLegacy.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/legacy/BiomeRainforestLegacy.java
@@ -5,6 +5,7 @@ import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.generate.feature.WorldFeature;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTree;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeFancy;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
@@ -16,7 +17,7 @@ public class BiomeRainforestLegacy
     }
 
     @Override
-    public WorldFeature getRandomWorldGenForTrees(final Random random) {
+    public @NotNull WorldFeature getTreeFeature(final @NotNull Random random) {
         return (random.nextInt(3) == 0) ? new WorldFeatureTreeFancy(Blocks.LEAVES_OAK.id(), Blocks.LOG_OAK.id()) : new WorldFeatureTree(Blocks.LEAVES_OAK.id(), Blocks.LOG_OAK.id(), 4);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/overworld/legacy/BiomeTaigaLegacy.java b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/legacy/BiomeTaigaLegacy.java
index 48842c748..8dac43f80 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/overworld/legacy/BiomeTaigaLegacy.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/legacy/BiomeTaigaLegacy.java
@@ -5,6 +5,7 @@ import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.generate.feature.WorldFeature;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeTaigaBushy;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeTaigaTall;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
@@ -16,7 +17,7 @@ public class BiomeTaigaLegacy
     }
 
     @Override
-    public WorldFeature getRandomWorldGenForTrees(final Random random) {
+    public @NotNull WorldFeature getTreeFeature(final @NotNull Random random) {
         if(random.nextInt(3) == 0)
         {
             return new WorldFeatureTreeTaigaTall(Blocks.LEAVES_PINE.id(), Blocks.LOG_PINE.id());
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java
index f2c6f85bc..c33818514 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java
@@ -16,7 +16,7 @@ public final class BiomeProviderNether
 {
     public static final Biome[] BIOMES_ORDER = {
             Biomes.NETHER_OLD_WORLD,
-            Biomes.NETHER_CRYSTAL_FIELD,
+            Biomes.NETHER_CRYSTAL_PLAINS,
             Biomes.NETHER_CRYSTAL_FOREST,
             Biomes.NETHER_SHELF,
             Biomes.NETHER_CRAG,
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
index f09a4fa87..29cb19e20 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
@@ -6,6 +6,7 @@ import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.LightIndexHelper;
+import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.biome.Biome;
@@ -15,6 +16,7 @@ import net.minecraft.core.world.pos.ChunkTilePos;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.core.world.season.SeasonManager;
+import net.minecraft.core.world.type.WorldType;
 import net.minecraft.core.world.weather.WeatherManager;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -253,7 +255,12 @@ public class ChunkCache
     }
 
     @Override
-    public boolean isRetro() {
-        return this.world.isRetro();
+    public @NotNull Dimension getDimension() {
+        return this.world.getDimension();
+    }
+
+    @Override
+    public @NotNull WorldType getWorldType() {
+        return this.world.getWorldType();
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/CavesLargeFeature.java b/game/core/src/main/java/net/minecraft/core/world/generate/CavesLargeFeature.java
index 8595a5bbe..107a88dc5 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/CavesLargeFeature.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/CavesLargeFeature.java
@@ -174,8 +174,8 @@ public class CavesLargeFeature extends LargeFeature {
 
                                     if (replaceTopBlock) {
                                         Biome biome = world.getBlockBiome(x, yIndex - 1, z);
-                                        int topBlockId = biome.topBlock;
-                                        int fillBlockId = biome.fillerBlock;
+                                        int topBlockId = biome.getSurfaceProperties().getTopBlock().id();
+                                        int fillBlockId = biome.getSurfaceProperties().getFillerBlock().id();
                                         int id = result.getBlock(x, yIndex - 1, z);
                                         if (id == fillBlockId) {
                                             result.setBlock(x, yIndex - 1, z, topBlockId);
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/RetroCavesLargeFeature.java b/game/core/src/main/java/net/minecraft/core/world/generate/RetroCavesLargeFeature.java
index 28b8e7d3b..06cabca62 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/RetroCavesLargeFeature.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/RetroCavesLargeFeature.java
@@ -166,8 +166,8 @@ public class RetroCavesLargeFeature extends LargeFeature {
 
                                         if (replaceTopBlock) {
                                             Biome biome = world.getBlockBiome(x, yIndex - 1, z);
-                                            int topBlockId = biome.topBlock;
-                                            int fillBlockId = biome.fillerBlock;
+                                            int topBlockId = biome.getSurfaceProperties().getTopBlock().id();
+                                            int fillBlockId = biome.getSurfaceProperties().getFillerBlock().id();
                                             int id = result.getBlock(x, yIndex - 1, z);
                                             if (id == fillBlockId) {
                                                 result.setBlock(x, yIndex - 1, z, topBlockId);
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/classic/ChunkGeneratorClassic.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/classic/ChunkGeneratorClassic.java
index 727182ed3..0d102f7c5 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/classic/ChunkGeneratorClassic.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/classic/ChunkGeneratorClassic.java
@@ -2,6 +2,7 @@ package net.minecraft.core.world.generate.chunk.classic;
 
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.CavesLargeFeature;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
index a55416817..e8a0637c9 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
@@ -3,6 +3,7 @@ package net.minecraft.core.world.generate.chunk.perlin.nether;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.biome.BiomeTags;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.*;
@@ -29,7 +30,7 @@ public class ChunkDecoratorNether
         );
         this.register("minecraft:decoration/nether/default/rubyglass_crystal_ceiling",
                 new ChunkDecorationBuilder(new WorldFeatureRubyglassCrystal(true))
-                        .withBiomeMask(new Biome[]{ Biomes.NETHER_CRYSTAL_FOREST, Biomes.NETHER_CRYSTAL_FIELD })
+                        .withBiomeMask(new Biome[]{ Biomes.NETHER_CRYSTAL_FOREST, Biomes.NETHER_CRYSTAL_PLAINS})
                         .withPositionSelector(PositionSelectors.UpperHeightRangeUniform)
                         .withPlacementMethod(((feature, world, chunk, random) -> {
                             int x = chunk.pos.x * 16;
@@ -44,7 +45,7 @@ public class ChunkDecoratorNether
 
         this.register("minecraft:decoration/nether/default/rubyglass_crystal_floor",
                 new ChunkDecorationBuilder(new WorldFeatureRubyglassCrystal(false, 25, 50))
-                        .withBiomeMask(new Biome[]{ Biomes.NETHER_CRYSTAL_FOREST, Biomes.NETHER_CRYSTAL_FIELD })
+                        .withBiomeMask(new Biome[]{ Biomes.NETHER_CRYSTAL_FOREST, Biomes.NETHER_CRYSTAL_PLAINS})
                         .withPositionSelector(PositionSelectors.UpperHeightRangeUniform)
                         .withPlacementMethod(((feature, world, chunk, random) -> {
                             int x = chunk.pos.x * 16;
@@ -59,21 +60,21 @@ public class ChunkDecoratorNether
 
         this.register("minecraft:decoration/nether/default/rubyglass_crystal_floor_2",
                 new ChunkDecorationBuilder(new WorldFeatureRubyglassCrystal(false,  20, 30))
-                        .withBiomeMask(new Biome[]{ Biomes.NETHER_CRYSTAL_FOREST, Biomes.NETHER_CRYSTAL_FIELD })
+                        .withBiomeMask(new Biome[]{ Biomes.NETHER_CRYSTAL_FOREST, Biomes.NETHER_CRYSTAL_PLAINS})
                         .withPositionSelector(PositionSelectors.UpperHeightRangeUniform)
                         .withPlacementMethod(new PlacementMethod.TriesPerChunk(4))
         );
 
         this.register("minecraft:decoration/nether/default/rubyglass_sprout_patch",
                 new ChunkDecorationBuilder(new WorldFeatureRubyglassSproutPatch())
-                        .withBiomeMask(new Biome[]{ Biomes.NETHER_CRYSTAL_FOREST, Biomes.NETHER_CRYSTAL_FIELD })
+                        .withBiomeMask(new Biome[]{ Biomes.NETHER_CRYSTAL_FOREST, Biomes.NETHER_CRYSTAL_PLAINS})
                         .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
                         .withPlacementMethod(new PlacementMethod.TriesPerChunk(20))
         );
 
         this.register("minecraft:decoration/nether/default/nether_water_spring",
                 new ChunkDecorationBuilder(new WorldFeatureNetherSpring(Blocks.FLUID_WATER_FLOWING.id()))
-                        .withBiomeMask(new Biome[]{ Biomes.NETHER_CRYSTAL_FOREST, Biomes.NETHER_CRYSTAL_FIELD, Biomes.NETHER_OLD_WORLD })
+                        .withBiomeMask(new Biome[]{ Biomes.NETHER_CRYSTAL_FOREST, Biomes.NETHER_CRYSTAL_PLAINS, Biomes.NETHER_OLD_WORLD })
                         .withPositionSelector(PositionSelectors.HeightRangeBiasedTop)
                         .withPlacementMethod(new PlacementMethod.TriesPerChunk(30))
         );
@@ -94,7 +95,7 @@ public class ChunkDecoratorNether
 
         this.register("minecraft:decoration/nether/default/pillar_netherrack",
                 new ChunkDecorationBuilder(new WorldFeaturePillar(Blocks.NETHERRACK.id(), false))
-                        .withBiomeMask(new Biome[]{ Biomes.NETHER_CRYSTAL_FIELD, Biomes.NETHER_CRYSTAL_FOREST, Biomes.NETHER_CRAG, Biomes.NETHER_SHELF })
+                        .withBiomeMask(new Biome[]{ Biomes.NETHER_CRYSTAL_PLAINS, Biomes.NETHER_CRYSTAL_FOREST, Biomes.NETHER_CRAG, Biomes.NETHER_SHELF })
                         .withPositionSelector(PositionSelectors.UpperHeightRangeUniform)
                         .withPlacementMethod(new PlacementMethod.ChanceToPlace(4))
         );
@@ -225,7 +226,7 @@ public class ChunkDecoratorNether
                 dy++;
                 Biome localBiome = world.getBlockBiome(dx, dy, dz);
 
-                if (localBiome != null && localBiome.hasSurfaceSnow() && (dy > 0 && dy < world.getHeightBlocks())) {
+                if (localBiome != null && localBiome.hasTag(BiomeTags.HAS_SURFACE_ASH) && (dy > 0 && dy < world.getHeightBlocks())) {
                     if (world.isAirBlock(dx, dy, dz) && world.getBlockMaterial(dx, dy - 1, dz).blocksMotion()) {
                         world.setBlock(dx, dy, dz, Blocks.LAYER_ASH.id());
                     }
